#include<windows.h>

// These probably shouldn't be globals, but it doesn't matter since I kinda force you to only display one at a time.
HBITMAP bmp = 0;
int height, width;
char* imageData;

void ErrorExit(char*); // from the other error.c file

// Forward definitions
LRESULT CALLBACK WndProc(HWND, unsigned int, WPARAM, LPARAM);
void ClientResize(HWND hWnd, int nWidth, int nHeight);




const char* cn = "piclol";

// The image data here is assumed to be 24 bits per pixel, left to right, top to bottom, no padding
int displayWin32(int w, int h, char* id){
	width = w;
	height = h;
	imageData = id;

	HINSTANCE hInstance = (HINSTANCE)GetModuleHandle(NULL);

	HWND hWnd;
	MSG Message;
	WNDCLASS wc;

	memset(&wc, 0, sizeof(wc));
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(hInstance, NULL);
	wc.hInstance = hInstance;
	wc.lpfnWndProc = WndProc;
	wc.lpszClassName = cn;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	if(!RegisterClass(&wc))
		return 0;

	hWnd = CreateWindow(cn, "Image", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, width, height,
		NULL, NULL, hInstance, NULL);

	ClientResize(hWnd, width, height);

	ShowWindow(hWnd, SW_SHOWNORMAL);
    
	while(GetMessage(&Message, hWnd, 0, 0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam) {
	switch(iMessage) {
		case WM_KEYDOWN:
		case WM_CLOSE:
		case WM_DESTROY:
  			if(bmp != 0) {
				DeleteObject(bmp);
				bmp = 0; // need to zero it out in case we're called again
			}
			PostQuitMessage(0);
		break;
		case WM_PAINT: {
			BITMAP bm;
			PAINTSTRUCT ps;
			int lol, wtf;

			HDC hdc = BeginPaint(hWnd, &ps);

			// If we haven't made the bitmap to paint to the window, do so now.
			if(bmp == 0) {
				BITMAPINFO infoheader;
				memset(&infoheader, 0, sizeof(infoheader));
				infoheader.bmiHeader.biSize = sizeof(infoheader.bmiHeader);
				infoheader.bmiHeader.biWidth = width;
				infoheader.bmiHeader.biHeight = height;
				infoheader.bmiHeader.biPlanes = 1;
				infoheader.bmiHeader.biBitCount = 24;
				infoheader.bmiHeader.biCompression = BI_RGB;
				int a, b, idx, idx2;
				char* bits;
				bmp = CreateDIBSection(
					hdc,
					&infoheader,
					DIB_RGB_COLORS,
					(void**) &bits,
					NULL,
					0);
				if(bmp == NULL) {
					goto fuck;
				}

				idx = 0;
				idx2 = 0;
				for(b = height-1; b > 0; b--) {
					wtf = 0;
					for(a = 0; a < width; a++) {
						bits[idx+2] = imageData[idx2++];
						bits[idx+1] = imageData[idx2++];
						bits[idx+0] = imageData[idx2++];
						idx += 3;
						wtf+=3;
					}

					int ugh = wtf%4;
					if(ugh)
					for(lol = 0; lol < 4-ugh; lol++)
						bits[idx++] = 0; // padding
				}

			}

			HDC hdcMem = CreateCompatibleDC(hdc);
			HBITMAP hbmOld = SelectObject(hdcMem, bmp);

			GetObject(bmp, sizeof(bm), &bm);

			BitBlt(hdc, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem, 0, 0, SRCCOPY);

			SelectObject(hdcMem, hbmOld);
			DeleteDC(hdcMem);
		  fuck:
		        EndPaint(hWnd, &ps);
		} break;
		  default:
			return DefWindowProc(hWnd, iMessage, wParam, lParam);
	}
	 return 0;
}

// I nabbed this from the 'net; it is supposed to make the window size a bit more accurate.
// FIXME: copyright unknown
void ClientResize(HWND hWnd, int nWidth, int nHeight)
 {
   RECT rcClient, rcWindow;
   POINT ptDiff;
     GetClientRect(hWnd, &rcClient);
     GetWindowRect(hWnd, &rcWindow);
   ptDiff.x = (rcWindow.right - rcWindow.left) - rcClient.right;
   ptDiff.y = (rcWindow.bottom - rcWindow.top) - rcClient.bottom;
   MoveWindow(hWnd,rcWindow.left, rcWindow.top, nWidth + ptDiff.x, nHeight + ptDiff.y, TRUE);
 }
